class SmsController < ApplicationController
  protect_from_forgery except: :receive
  
  require 'mysql2'
  
  # http://localhost:3000/sms/send_sms?ops_ip_address=192.168.115.193&api_extension=9994&recipient=2000&message="Hello+World!"
  def send_sms
    sender = params[:sender] == nil ? "" : URI::encode(params[:sender])
    delivery_report_url = params[:delivery_report_url] == nil ? "" : URI::encode(params[:delivery_report_url])
    message = URI::encode(params[:message]);
    recipient = URI::encode(params[:recipient])
    redirect_to "http://#{params[:ops_ip_address]}:7780/?Command=SendSms&ApiExtension=#{params[:api_extension]}&Sender=#{sender}&Recipient=#{recipient}&Message=#{message}&DeliveryReportURL=#{delivery_report_url}"
  end
  
  # http://localhost:3000/sms/receive
  def receive
    begin
      
      config = YAML::load_file("config/database.yml")["development"]
      config["host"] = config["hostname"]
      con = Mysql2::Client.new(config)

      con.query("CREATE DATABASE IF NOT EXISTS Ozeki_Received_SMS_Messages;")
      con.query("CREATE TABLE IF NOT EXISTS Ozeki_Received_SMS_Messages.Received_Messages (sender VARCHAR(30), recipient VARCHAR(30), message VARCHAR(160));")

      if ((params[:Recipient] != nil) && (params[:Message] != nil))
        sender = params[:Sender] == nil ? "" : params[:Sender]  
        con.query("INSERT INTO Ozeki_Received_SMS_Messages.Received_Messages (sender, recipient, message) VALUES ('" + sender + "', '" + params[:Recipient] + "', '" + params[:Message] + "');")
      end
      
    rescue Mysql2::Error => e
      puts e.errno
      puts e.error
    ensure
      con.close if con
    end
  end
  
end
